> For the complete documentation index, see [llms.txt](https://docs.denvrdata.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.denvrdata.com/docs/api-reference/vpcs.md).

# VPCs

## GET /api/v1/vpcs/GetVpcs

> Get a list of VPCs

```json
{"openapi":"3.0.4","info":{"title":"DenvrCloud API","version":"v1"},"tags":[{"name":"vpcs"}],"paths":{"/api/v1/vpcs/GetVpcs":{"get":{"tags":["vpcs"],"summary":"Get a list of VPCs","operationId":"ApiV1VpcsGetvpcsGet","parameters":[{"name":"cluster","in":"query","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/ListResultDtoOfVpcDetailsItem"}},"application/json":{"schema":{"$ref":"#/components/schemas/ListResultDtoOfVpcDetailsItem"}},"text/json":{"schema":{"$ref":"#/components/schemas/ListResultDtoOfVpcDetailsItem"}}}},"400":{"description":"Bad Request"},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}}},"components":{"schemas":{"ListResultDtoOfVpcDetailsItem":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/VpcDetailsItem"},"nullable":true}},"additionalProperties":false},"VpcDetailsItem":{"type":"object","properties":{"id":{"type":"string","nullable":true},"name":{"type":"string","nullable":true},"cluster":{"type":"string","nullable":true},"tenancyName":{"type":"string","nullable":true},"ipRange":{"type":"string","nullable":true},"createdAt":{"type":"string","format":"date-time"},"blockIntraVpcComms":{"type":"boolean"},"isDefault":{"type":"boolean"}},"additionalProperties":false}}}}
```

## GET /api/v1/vpcs/GetVpc

> Get detailed information about a specific VPC

```json
{"openapi":"3.0.4","info":{"title":"DenvrCloud API","version":"v1"},"tags":[{"name":"vpcs"}],"paths":{"/api/v1/vpcs/GetVpc":{"get":{"tags":["vpcs"],"summary":"Get detailed information about a specific VPC","operationId":"ApiV1VpcsGetvpcGet","parameters":[{"name":"Id","in":"query","description":"Unique identifier for a resource within the cluster","required":true,"schema":{"type":"string"}},{"name":"Cluster","in":"query","description":"The cluster you're operating on","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"application/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"text/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}}}},"400":{"description":"Bad Request"},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}}},"components":{"schemas":{"VpcDetailsItem":{"type":"object","properties":{"id":{"type":"string","nullable":true},"name":{"type":"string","nullable":true},"cluster":{"type":"string","nullable":true},"tenancyName":{"type":"string","nullable":true},"ipRange":{"type":"string","nullable":true},"createdAt":{"type":"string","format":"date-time"},"blockIntraVpcComms":{"type":"boolean"},"isDefault":{"type":"boolean"}},"additionalProperties":false}}}}
```

## POST /api/v1/vpcs/CreateVpc

> Create a new VPC

```json
{"openapi":"3.0.4","info":{"title":"DenvrCloud API","version":"v1"},"tags":[{"name":"vpcs"}],"paths":{"/api/v1/vpcs/CreateVpc":{"post":{"tags":["vpcs"],"summary":"Create a new VPC","operationId":"ApiV1VpcsCreatevpcPost","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateVpcInputExt"}},"text/json":{"schema":{"$ref":"#/components/schemas/CreateVpcInputExt"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CreateVpcInputExt"}}}},"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"application/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"text/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}}}},"400":{"description":"Bad Request"},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}}},"components":{"schemas":{"CreateVpcInputExt":{"required":["cluster","name"],"type":"object","properties":{"name":{"minLength":1,"type":"string","description":"name of the VPC. should start with {tenancyName}- \nin case of creating default VPC, name should be {tenancyName}"},"blockIntraVpcComms":{"type":"boolean","description":"if set to true, this VPC will block any intra-VPC communications\nif ommited, default is false"},"isDefault":{"type":"boolean","description":"if set to true, this VPC will be the default VPC for the cluster\nonly one VPC can be default per cluster. \nif omitted, default is false"},"cluster":{"minLength":1,"type":"string","description":"The cluster you're operating on"}},"additionalProperties":false},"VpcDetailsItem":{"type":"object","properties":{"id":{"type":"string","nullable":true},"name":{"type":"string","nullable":true},"cluster":{"type":"string","nullable":true},"tenancyName":{"type":"string","nullable":true},"ipRange":{"type":"string","nullable":true},"createdAt":{"type":"string","format":"date-time"},"blockIntraVpcComms":{"type":"boolean"},"isDefault":{"type":"boolean"}},"additionalProperties":false}}}}
```

## DELETE /api/v1/vpcs/DestroyVpc

> Destroy a VPC

```json
{"openapi":"3.0.4","info":{"title":"DenvrCloud API","version":"v1"},"tags":[{"name":"vpcs"}],"paths":{"/api/v1/vpcs/DestroyVpc":{"delete":{"tags":["vpcs"],"summary":"Destroy a VPC","operationId":"ApiV1VpcsDestroyvpcDelete","parameters":[{"name":"Id","in":"query","description":"Unique identifier for a resource within the cluster","required":true,"schema":{"type":"string"}},{"name":"Cluster","in":"query","description":"The cluster you're operating on","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"text/plain":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"application/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}},"text/json":{"schema":{"$ref":"#/components/schemas/VpcDetailsItem"}}}},"400":{"description":"Bad Request"},"401":{"description":"Unauthorized"},"403":{"description":"Forbidden"},"500":{"description":"Internal Server Error"}}}}},"components":{"schemas":{"VpcDetailsItem":{"type":"object","properties":{"id":{"type":"string","nullable":true},"name":{"type":"string","nullable":true},"cluster":{"type":"string","nullable":true},"tenancyName":{"type":"string","nullable":true},"ipRange":{"type":"string","nullable":true},"createdAt":{"type":"string","format":"date-time"},"blockIntraVpcComms":{"type":"boolean"},"isDefault":{"type":"boolean"}},"additionalProperties":false}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.denvrdata.com/docs/api-reference/vpcs.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
